\chapter{Robust control design using mixed sensitivity approach}
Mixed-sensivity is the name given to transfer shaping problems in which the sensitivity function $ \mathbf{S}=(\mathbf{I}+\mathbf{GK}^{-1}) $ is shaped along with one or more other colsed-loop transfer functions such as $\mathbf{KS}$ or the complementary sensitivity transfer function $\mathbf{T}=\mathbf{I}-\mathbf{S}$ depending on the goals we have, whether we want disturbance rejection, reference tracking or noise canceling. 

\section{$H_{\infty}$ loop-shaping}
Before starting to search for a controller, in robust control the designer has to chose weights based on which the system must be checked for performance at the end.
For performance, small singular values of $\mathbf{S}$ over low frequencies are preferred. Given that we have the free choice as a designer, we decide for a $PT_1$ performance weight:

\begin{equation}
	\begin{aligned}
		w_P=\frac{0.4}{s+0.1} 
	\end{aligned}
	\label{eq:performance_weight_mp}
\end{equation}

and for the non-minimal phase system:
\begin{equation}
\begin{aligned}
	w_{P_{non}}=\frac{0.004}{s+0.001}
\end{aligned}
\label{eq:performance_weight_np}
\end{equation}

\begin{figure}[!h]
	\centering
	\includegraphics[width=0.5\textwidth]{images/performance_weights}
	\caption{Performance weights }
	\label{fig:performance_weights}
\end{figure}
For uncertainty we apply the already presented output multiplicative uncertainty weights \ref{eq:wo} and \ref{eq:wonon}.

\section{$H_{\infty}$ mixed sensitivity design prerequisites }
We firstly start by defining the exogenous input $\mathbf{w}$ and the error signal $\mathbf{z}$ to be minimized. Since we consider a tracking problem the single exogenous input is $\mathbf{w=r}$. On the other hand the error signal depends from the type of uncertainty. For output multiplicative uncertainty we have $\mathbf{z}=\begin{bmatrix}\mathbf{W_1e} \\\mathbf{W_2y}\end{bmatrix}$, which correspond to a solution of a $\mathbf{S/T}$ mixed-sensitivity minimization. $\mathbf{S}$ is weighted with $\mathbf{W_1}$ for performance and $\mathbf{T}$ is weighted with $\mathbf{W_2}$ for uncertainty.\newline
\begin{figure}[!h]
	\centering
	\includegraphics[width=0.8\textwidth]{images/mixed_sensi.jpeg}
	\caption{Generalized plant for mixed sensitivity }
	\label{fig:mixed_sensitivity_generalized_plant}
\end{figure}
%\input{images/mixed_sensi.tex}

In order to keep the problem simple we decide to design $\mathbf{W_1}$ and $\mathbf{W_2}$ with scalar weights.
For good controlling performance we want the singular values of $\mathbf{S}$ to be small over the low frequencies. To do this we select $w_1(s)$ to be low-pass filter with bandwidth equal to that of closed loop system. That is we choose:
\begin{equation}
\begin{aligned}
		w_1(s)=(0.8\frac{(s+0.5)}{(s+0.005)})^2
\end{aligned}
\label{w1}
\end{equation}

The weighting of $\mathbf{T}$ is chosen complementary to that of $\mathbf{S}$. We want to keep the singular values of the complementary sensitivity small for high frequencies. This leads to:

\begin{equation}
\begin{aligned}
	w_2(s)=0.8\frac{(s+0.01)}{(s/17+0.1)}
\end{aligned}
\label{w2}
\end{equation}

In similar way, but keeping in mind that the non-min phase system is slower we choose the weight $w_{1_{non}}(s)$ to have a bandwidth $10 \frac{rad}{s}$ smaller than $w_1(s)$ as shown in Fig.~\ref{fig:w1}. The idea for choosing such weights was motivated from \cite{lund_insti}

\begin{equation}
\begin{aligned}
w_{1_{non}}(s)=(0.8\frac{(s+0.07)}{(s+0.0007)})^2
\end{aligned}
\label{w11}
\end{equation}


\begin{figure}[!h]
	\centering
	\includegraphics[width=0.61\textwidth]{images/w1}
	\caption{Bode diagram of $w_1(s)$ and $w_{1_{non}}(s)$ }
	\label{fig:w1}
\end{figure}


%As mentioned before $\mathbf{KS}$ is important for robust stability with respect to uncertainty modeled as additive plant perturbation. 
We choose $w_{2_{non}}(s)$ to be a scalar high-pass filter with crossover frequency approximately equal to that of the closed loop system:

\begin{equation}
\begin{aligned}
	w_{2_{non}}(s)=0.8\frac{(s+0.001)}{(s/7+0.01)}
\end{aligned}
\label{w2_non}
\end{equation}

The bode plots of \ref{w2} and \ref{w2_non} are presented in Fig.~\ref{fig:w2}
\begin{figure}[!h]
	\centering
	\includegraphics[width=0.61\textwidth]{images/w2}
	\caption{Bode diagram of $w_2(s)$ and $w_{2_{non}}(s)$ }
	\label{fig:w2}
\end{figure}
%
%	FIGURE of mixed-sensivity
%
%\newpage
\clearpage
Now that we have the weighs we are ready to find the controllers $\mathbf{K}_{min}^{\infty}$ and $\mathbf{K}_{non-min}^\infty$ which minimize
\[
\left| \left| \begin{bmatrix}
	w_1(s)\mathbf{S} \\ 
	w_2(s)\mathbf{T}
\end{bmatrix} \right| \right|_\infty
%\text{and   }
%\left| \left| \begin{bmatrix}
%w_{1_{non}}(s)\mathbf{S} \\ 
%w_{2_{non}}(s)\mathbf{KS}
%\end{bmatrix} \right| \right|_\infty
\]

This $H_\infty$ minimization problem cannot be solved in closed form. That is why in practice one solves it suboptimaly by giving a bound $\gamma$, compared to which the objective function should be smaller than.
In Matlab the mixed sensitivity $H_\infty$ controller can be computed very simple using \textit{mixsync} command.\newline
The respective step responses of the linear and non-linear model are shown in Fig.~\ref{fig:mixed_sensitivity_linear}. We see that mixed sensitivity $H_\infty$ clearly improves the resting time, compared to the decentralized controller.
%The non-linear model on the non-min phase operating point suffers from oscillations. This kind of behaviour is expected since the RHP-zero forces an initial zero border cross in the opposite direction, which in the nonlinear model is seen as zero, because of saturation and the fact that heights can not become negative. 
Both mixed sensitivity $H_\infty$ controllers have order of 10 (i.e have 10 states).

\begin{figure}[!h]
	\centering
	\includegraphics[width=0.82\textwidth]{images/mixed_sens_linear2}
	\caption{Step response of the linear model in both operating points }
	\label{fig:mixed_sensitivity_linear}
\end{figure}


%\begin{figure}[!h]
%	\centering
%	\includegraphics[height=4.1cm,width=0.6\textwidth]{images/mixed_sens_nonlinear1}
%	\caption{Step response of the nonlinear model in the min phase operating point}
%	\label{fig:mixed_sensitivity_nonlinear1}
%\end{figure}


%\begin{figure}[!h]
%	\centering
%	\includegraphics[height=4.1cm,width=0.6\textwidth]{images/mixed_sens_nonlinear2}
%	\caption{Step response of the nonlinear model on the non-min phase operating point }
%	\label{fig:mixed_sensitivity_nonlinear2}
%\end{figure}

\newpage
\section{Nonlinear model and a $H_{\infty}$ controller}

Once noise in form of white noise is introduced the min phase system deteriorates, Fig.~\ref{fig:sensor_noise_bad}.
%On the other hand, the non-min phase system delivers similar results. One can explain his with the different bandwidths of the systems. The min-phase system has a much bigger bandwidth and so allows a much bigger noise  spectrum compared to the non-min phase system. 
This shows that the $H_\infty$ - controller is inappropriate if sensor noise is included. We dealt with that by adding a third weight $w_3(s)=5$ for the non-min phase systems and solving the following $H_\infty$ minimizing problem:
\begin{equation}
\begin{aligned}
\left| \left| \begin{bmatrix}
w_1(s)\mathbf{S} \\ 
w_2(s)\mathbf{T} \\
w_3(s)\mathbf{KS} 
\end{bmatrix} \right| \right|_\infty
\end{aligned}
\end{equation}

\begin{figure}[!h]
	\centering
	\includegraphics[height=5.1cm,width=0.6\textwidth]{images/sensor_noise_bad}
	\caption{Step response with sensor noise}
	\label{fig:sensor_noise_bad}
\end{figure}

The new controller is now able to attenuate noise and deliver better results, Fig.~\ref{fig:sensor_noise_good}.

\begin{figure}[!h]
	\centering
	\includegraphics[height=5.1cm,width=0.6\textwidth]{images/sensor_noise_good}
	\caption{Step response with sensor noise}
	\label{fig:sensor_noise_good}
\end{figure}


\clearpage
\section{Robust performance}
In the following the weights \ref{eq:performance_weight_mp} and \ref{eq:performance_weight_np} are used to evaluate performance. For the uncertainty we use the output multiplicative uncertainty weights.
In addition to that a performance analysis of the system with parametric uncertainty based on the structure singular value is performed and compared to the $H_\infty$ analysis.
\begin{figure}[!h]
	\centering
	\includegraphics[width=0.8\textwidth]{images/mixed_sensi.png}
	\caption{Generalized plant}
	\label{fig:generalized_plant}
\end{figure}

According to Fig.~\ref{fig:generalized_plant} with the MIMO rule we  get the generalized plant matrix:

\begin{equation}
	\begin{aligned}
	\mathbf{P}=
	\begin{bmatrix}
		\mathbf{0}& \quad \mathbf{0}& \quad w_o\mathbf{G}& \\
		\mathbf{W_P}& \quad w_P\mathbf{I}& \quad w_P\mathbf{G}& \\
		\mathbf{-I}& \quad \mathbf{I}& \quad \mathbf{-G}&
	\end{bmatrix}
	\end{aligned}
\end{equation}

which shows the transfer function from the input $\begin{bmatrix}\mathbf{u_\Delta} \\\mathbf{r} \\ \mathbf{u}\end{bmatrix}$ to the output $\begin{bmatrix}\mathbf{y_\Delta} \\\mathbf{z} \\ \mathbf{v}\end{bmatrix}$

From there, with a given controller one can calculate the $\mathbf{N}\Delta$ structure as 

\begin{equation}
\begin{aligned}
\mathbf{N} = \mathcal{F}_l(\mathbf{P},\mathbf{K})=
\begin{bmatrix}
-wo\mathbf{T}& \quad wo\mathbf{T}& \\
-w_P\mathbf{S}& \quad w_P\mathbf{S}& 
\end{bmatrix}
\end{aligned}
\end{equation}




\subsubsection{Nominal Stability}
Systems in both operating points with both type of controllers are nominally stable because there is no RHP zero/pole cancellation and at least one loop is stable, e.g. $\mathbf{S}$.

\subsubsection{Robust Stability}
In order to measure robust stability the uncertainty weight $w_o$ is used.
With that said we get for robust stability
\[\mathbf{RS}<=>\left|\left|-wo\mathbf{T}\right|\right|_\infty=\left|\left|\mathbf{N_{11}}\right|\right|_\infty<1\]
We see from Table. 3.1 that only the min phase system satisfies robust stability. The non-min phase system is unstable with an $H_\infty$ norm of 1.5. Decentralized controller deliver $\infty$ for non-min phase system which corresponds to non robust stability. As expected $H_\infty$ norm is not very exact since it doesn't consider the structure of the uncertainty. If we observe the bode plot of $\mu$ structed singular value, we notice that both decentralized controllers stably robustify the systems.
\begin{figure}[!h]
	\centering
	\includegraphics[height=4.4cm,width=0.5\textwidth]{images/ussv_RS}
	\caption{$\mu_{\Delta}(\mathbf{N_{11}})$}
	\label{fig:ussv_rs}
\end{figure}


\subsubsection{Nominal Performance}
\[\mathbf{NP}<=>\left|\left|w_P\mathbf{S}\right|\right|_\infty=\left|\left|\mathbf{N_{22}}\right|\right|_\infty<1\]
As seen in Table 3.1 the systems with decentralized controller fail to satisfy nominal performance. Fig.~\ref{fig:ussv_np} on the other hand shows that  nominal stability is fulfilled by both systems for both types of controllers.
\begin{figure}[!h]
	\centering
	\includegraphics[height=4.4cm,width=0.5\textwidth]{images/ussv_NP}
	\caption{$\mu_{\Delta_P}(\mathbf{N_{22}})$}
	\label{fig:ussv_np}
\end{figure}
\clearpage
\subsubsection{Robust Performance}\label{tab:robust_perfo}

Robust performance is checked using the weights $w_P=\frac{0.4}{s+0.1}$ and $w_P=\frac{0.004}{s+0.001}$.
\[\mathbf{RP}<=>\left|\left|\mathbf{N}\right|\right|_\infty=\left|\left|
\begin{bmatrix} -wo\mathbf{T}& \quad wo\mathbf{T}& \\
-w_1\mathbf{S}& \quad w_1\mathbf{S}& 
\end{bmatrix}}\right|\right|_\infty<1\]
From Table. 3.1 none of the systems fulfills robust performance.
Structured singular value analysis Fig.~\ref{fig:ussv_rp} in contrary to $H_\infty$ norm indicates that the min-phase system satisfies robust performance for both controllers.

\begin{figure}[!h]
	\centering
	\includegraphics[height=5cm,width=0.5\textwidth]{images/ussv_RP}
	\caption{$\mu_\Delta(\mathbf{N})$}
	\label{fig:ussv_rp}
\end{figure}



\begin{center}
	\begin{tabular}{ |c|c|c|c| } 
		\hline
		& $\left|\left|N_{11}\right|\right|_\infty$ & $\left|\left|N_{22}\right|\right|_\infty$ &
		$\left|\left|N\right|\right|_\infty$\\  
		\hline
		min phase $H_\infty$ & 0.600 & 0.8051
		& 1.16 \\ 
		non-min phase $H_\infty$ & 2.23 & 0.9682 & 3.35 \\ 
		min phase dec. Contr. & 0.61 & $\infty$ & $\infty$ \\ 
		non-min phase dec. Contr. & $\infty$ & $\infty$ & $\infty$ \\ 
		\hline
	\end{tabular}
	\captionof{table}{Performance table} 
	\label{tab:robust_perf}
\end{center}



